package board;

import java.awt.Color;
import java.awt.Graphics;

public class DraughtPiece {
	
	private final Color pieceColor;
	private String pieceType;
	
	private int row;
	private int col;

	public DraughtPiece(Color pieceColour, String pieceType, int currentCol, int currentRow) {
		this.pieceColor=pieceColour;
		this.pieceType=pieceType;
		this.row=currentRow;
		this.col=currentCol;
	}
	
	public void drawDraughtPiece(Graphics graphicObject, int originX, int originY) {
		graphicObject.setColor(pieceColor);
		
		int currentSquareX=originX+(col*62);
		int currentSquareY=originY+(row*62);
		
		if(pieceType=="man") {
			graphicObject.fillOval(currentSquareX+15, currentSquareY+15, 30, 30);
		} 
		if(pieceType=="king") {
			graphicObject.setColor(Color.YELLOW);
			graphicObject.fillOval(currentSquareX+10, currentSquareY+10, 40, 40);
			graphicObject.setColor(pieceColor);
			graphicObject.fillOval(currentSquareX+15, currentSquareY+15, 30, 30);

		}
	}
	
	public int getRow() {
		return row;
	}
	
	public int getCol() {
		return col;
	}
	
	public Color getColor() {
		return pieceColor;
	}
	
	public Color getOppositeColor() {
		Color oppositeColor;
		if(pieceColor==Color.WHITE) {
			oppositeColor=Color.RED;
		} else {
			oppositeColor=Color.WHITE;
		}
		return oppositeColor;
	}
	
	public String getPieceType() {
		if(pieceColor==Color.WHITE) {
			if(row==1) {
				pieceType="king";
			}
		}
		if(pieceColor==Color.RED) {
			if(row==8) {
				pieceType="king";
			}
		}
		return pieceType;
	}
	
	public void updatePieceType() {
		if(pieceColor.equals(Color.WHITE)) {
			if(row==1) {
				pieceType="king";
			}
		} if(pieceColor.equals(Color.RED)) {
			if(row==8) {
				pieceType="king";
			}
		}
		
		
	}

	public void drawLegalBorder(Graphics graphicObject, int originX, int originY) {
		graphicObject.setColor(Color.YELLOW);
		graphicObject.drawRect(originX+(62*col), originY+(62*row), 62, 62);
	}
	
}
