package gameControl;

import java.awt.Color;
import java.util.ArrayList;

import board.DraughtPiece;

public class GameState {
	private ArrayList<DraughtPiece> gameState;
	private int playerTurn;

	public GameState(ArrayList<DraughtPiece> initialGameState) {
		gameState=initialGameState;
		playerTurn=1;
	}
	
	public ArrayList<DraughtPiece> getGameStatePieces() {
		return gameState;
	}
	
	public void setGameState(ArrayList<DraughtPiece> newGameState) {
		gameState=newGameState;
	}
	
	public int getTurn() {
		return playerTurn;
	}
	
	public boolean gameRunning() {
		return true;
	}
	
	public void setTurn(int nextTurn) {
		playerTurn=nextTurn;
	}

	public int getNextTurn() {
		int nextTurn;
		if(playerTurn==1) {
			nextTurn=2;
		} else {
			nextTurn=1;
		}
		return nextTurn;
	}
	
	public ArrayList<DraughtPiece> getWhitePieces() {
		ArrayList<DraughtPiece> whitePieces=new ArrayList<DraughtPiece>();
		for(DraughtPiece piece:gameState) {
			if(piece.getColor()==Color.WHITE) {
				whitePieces.add(piece);
			}
		}
		return whitePieces;
	}
	
	public ArrayList<DraughtPiece> getRedPieces() {
		ArrayList<DraughtPiece> redPieces=new ArrayList<DraughtPiece>();
		for(DraughtPiece piece:gameState) {
			if(piece.getColor()==Color.RED) {
				redPieces.add(piece);
			}
		}
		return redPieces;
	}

}
