package moveFinders;

import java.awt.Color;
import java.util.ArrayList;

import board.DraughtPiece;

public class LegalPieceFinder {
		
	public ArrayList<DraughtPiece> findLegalPieces(int playerNum, ArrayList<DraughtPiece> gameState) {
		ArrayList<DraughtPiece> legalPieces=new ArrayList<DraughtPiece>();
		if(playerNum==1) {
			legalPieces=findWhiteLegalPieces(gameState);
		}
		if(playerNum==2) {
			legalPieces=findRedLegalPieces(gameState);
		}
		return legalPieces;
		
	}

	private ArrayList<DraughtPiece> findWhiteLegalPieces(ArrayList<DraughtPiece> gameState) {
		ArrayList<DraughtPiece> whiteLegalPieces=new ArrayList<DraughtPiece>();
		ArrayList<DraughtPiece> priorityWhiteLegalPieces=new ArrayList<DraughtPiece>();
		for(DraughtPiece piece:gameState) {
			if(piece.getColor()==Color.WHITE) {
				LegalMoveFinder legalMoveFinder=new LegalMoveFinder();
				ArrayList<int[]> virtualLegalMoves=new ArrayList<int[]>();
				
				virtualLegalMoves=legalMoveFinder.findDiagonalMoves(piece, gameState);
				ArrayList<int[]> jumpMoves=legalMoveFinder.findJumpMoves(piece, virtualLegalMoves, gameState);
				
				jumpMoves=legalMoveFinder.removeOccupiedSquares(jumpMoves, gameState);
				jumpMoves=legalMoveFinder.removeOutOfBoundsSquares(jumpMoves);
				if(!jumpMoves.isEmpty()) {
					priorityWhiteLegalPieces.add(piece);
				}
				
				virtualLegalMoves.addAll(legalMoveFinder.findJumpMoves(piece, virtualLegalMoves, gameState));
				virtualLegalMoves=legalMoveFinder.removeOccupiedSquares(virtualLegalMoves, gameState);
				virtualLegalMoves=legalMoveFinder.removeOutOfBoundsSquares(virtualLegalMoves);
				if(!virtualLegalMoves.isEmpty()) {
					whiteLegalPieces.add(piece);
				}
			}
		}
		
		if(!priorityWhiteLegalPieces.isEmpty()) {
			return priorityWhiteLegalPieces;
		} else {
			return whiteLegalPieces;
		}
		
	}

	private ArrayList<DraughtPiece> findRedLegalPieces(ArrayList<DraughtPiece> gameState) {
		ArrayList<DraughtPiece> redLegalPieces=new ArrayList<DraughtPiece>();
		ArrayList<DraughtPiece> priorityRedLegalPieces=new ArrayList<DraughtPiece>();
		for(DraughtPiece piece:gameState) {
			if(piece.getColor()==Color.RED) {
				LegalMoveFinder legalMoveFinder=new LegalMoveFinder();
				ArrayList<int[]> virtualLegalMoves=new ArrayList<int[]>();
				
				virtualLegalMoves=legalMoveFinder.findDiagonalMoves(piece, gameState);
				ArrayList<int[]> jumpMoves=legalMoveFinder.findJumpMoves(piece, virtualLegalMoves, gameState);
				
				jumpMoves=legalMoveFinder.removeOccupiedSquares(jumpMoves, gameState);
				jumpMoves=legalMoveFinder.removeOutOfBoundsSquares(jumpMoves);
				if(!jumpMoves.isEmpty()) {
					priorityRedLegalPieces.add(piece);
				}
	
				virtualLegalMoves.addAll(jumpMoves);
				virtualLegalMoves=legalMoveFinder.removeOccupiedSquares(virtualLegalMoves, gameState);
				virtualLegalMoves=legalMoveFinder.removeOutOfBoundsSquares(virtualLegalMoves);
				if(!virtualLegalMoves.isEmpty()) {
					redLegalPieces.add(piece);
				}
				
			}
		}
		if(!priorityRedLegalPieces.isEmpty()) {
			return priorityRedLegalPieces;
		} else {
			return redLegalPieces;
		}
	}

	public ArrayList<DraughtPiece> findPossibleJumpPiece(DraughtPiece movedPiece, ArrayList<DraughtPiece> gameStatePieces) {
		ArrayList<DraughtPiece> legalPieces=new ArrayList<DraughtPiece>();
		
		LegalMoveFinder jumpTester=new LegalMoveFinder();
		ArrayList<int[]> testMoves=new ArrayList<int[]>();
		testMoves=jumpTester.findJumpMoves(movedPiece, jumpTester.findDiagonalMoves(movedPiece, gameStatePieces), gameStatePieces);
		testMoves=jumpTester.removeOccupiedSquares(testMoves, gameStatePieces);
		testMoves=jumpTester.removeOutOfBoundsSquares(testMoves);
		
		if(!testMoves.isEmpty()) {
			legalPieces.add(movedPiece);
		}
		
		return legalPieces;
	}

	 

}
